#pragma once

#include "Builder/Builders/IGameBuilder.h"

class GameBuilderDirector {
public:
    std::unique_ptr<GameState> build(IStateManager& state_manager);
public:
    GameBuilderDirector(std::unique_ptr<IGameBuilder> ptr_builder,
    const sf::VideoMode& video_mode, const std::string& window_title, float dynamic_objects_ratio);
private:
    std::string m_window_title;
    sf::VideoMode m_video_mode;
    float m_dynamic_object_ratio;
    std::unique_ptr<IGameBuilder> m_ptr_builder;
};