#pragma once

#include <SFML/Graphics/RenderWindow.hpp>
#include "Config.h"

class IWindowKeeper {
protected:
    virtual void event_handling() = 0;
    virtual void update() = 0;
    virtual void render() = 0;
public:
    IWindowKeeper(const sf::VideoMode& video_mode, const std::string& window_title) :
        m_window(video_mode, window_title) {
        m_window.setFramerateLimit(config::FRAME_RATE_LIMIT);
//        m_window.setKeyRepeatEnabled(false);
    }
protected:
    sf::RenderWindow m_window;
};