#pragma once

#include "IDynamicEntity.h"
#include "Draw/Textures/EnemyTexture.h"

class Enemy: public IDynamicEntity {
public:
    void prepare_for_drawing() override;
    void draw_into(sf::RenderWindow& window) const override;
    std::unique_ptr<IDynamicEntity> clone() const override;
    void action() override;
    std::unique_ptr<IGameEvent> accept(IVisitor* ptr_visitor) override;
private:
    void set_texture(Texture* ptr_texture);
public:
    Enemy();
public:
    config::Direction m_direction = config::RIGHT;
private:
    sf::RectangleShape m_rectangle;
    sf::Clock m_stopwatch;
    sf::Sprite m_sprite;
    Texture* m_ptr_texture;
    inline static const size_t m_rect_count = 2;
};