#pragma once

#include "IEntity.h"
#include <Visit/IVisitor.h>
#include "Draw/Textures/PacmanTexture.h"

class Pacman: public IEntity, public IVisitor {
public:
    void prepare_for_drawing() override;
    void draw_into(sf::RenderWindow& window) const override;
    void move(Room::Direction direction);
    std::unique_ptr<IGameEvent> visit(Food* ptr_food) override;
    std::unique_ptr<IGameEvent> visit(Enemy* ptr_enemy) override;
    void next_animation();
private:
    void set_texture(Texture* ptr_texture);
public:
    Pacman();
public:
    sf::Clock m_clock;
    config::Direction m_direction = config::RIGHT;
private:
    sf::Sprite m_sprite;
    Texture* m_ptr_texture;
    inline static const size_t m_rect_count = 2;
};