#pragma once

#include "IStaticEntity.h"
#include "Draw/Textures/FoodTexture.h"

class Food: public IStaticEntity {
public:
    void prepare_for_drawing() override;
    void draw_into(sf::RenderWindow& window) const override;
    std::unique_ptr<IStaticEntity> clone() const override;
    std::unique_ptr<IGameEvent> accept(IVisitor* ptr_visitor) override;
private:
    void set_texture(Texture* ptr_texture);
public:
    Food();
private:
    sf::CircleShape m_circle;
    sf::Sprite m_sprite;
    Texture* m_ptr_texture;
};