#include "MazeContent/Entities/StaticEntities/Food.h"
#include "Config.h"
#include <Events/IGameEvent.h>

Food::Food() {
    set_texture(&FoodTexture::Instance());
}

std::unique_ptr<IStaticEntity> Food::clone() const {
    return std::make_unique<Food>(*this);
}

void Food::set_texture(Texture* ptr_texture) {
    m_ptr_texture = ptr_texture;
}

void Food::prepare_for_drawing() {
    m_sprite.setTexture(m_ptr_texture->get_texture());
    m_sprite.setPosition(m_ptr_room->get_position() + sf::Vector2f(-18, -18));
    m_sprite.setScale(0.15, 0.15);
}

void Food::draw_into(sf::RenderWindow& window) const {
    window.draw(m_sprite);
}

std::unique_ptr<IGameEvent> Food::accept(IVisitor* ptr_visitor) {
    return ptr_visitor->visit(this);
}